<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <title>Front End</title>

  <!-- Google Font: Source Sans Pro -->
  <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback">
  <!-- Font Awesome -->
  <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css">
  <!-- DataTables -->
  <link rel="stylesheet" href="plugins/datatables-bs4/css/dataTables.bootstrap4.min.css">
  <link rel="stylesheet" href="plugins/datatables-responsive/css/responsive.bootstrap4.min.css">
  <link rel="stylesheet" href="plugins/datatables-buttons/css/buttons.bootstrap4.min.css">
  <!-- Theme style -->
  <link rel="stylesheet" href="dist/css/adminlte.min.css">
</head>
<body class="hold-transition sidebar-mini">
<div class="wrapper">
  <!-- Main Sidebar Container -->
  <aside class="main-sidebar sidebar-dark-primary elevation-4">
    <!-- Brand Logo -->
    <a href="index3.html" class="brand-link">
      <img src="dist/img/AdminLTELogo.png" alt="AdminLTE Logo" class="brand-image img-circle elevation-3" style="opacity: .8">
      <span class="brand-text font-weight-light">Front End</span>
    </a>

    <!-- Sidebar -->
    <div class="sidebar">
      <!-- Sidebar user (optional) -->
      <div class="user-panel mt-3 pb-3 mb-3 d-flex">
        <div class="image">
          <img src="dist/img/user2-160x160.jpg" class="img-circle elevation-2" alt="User Image">
        </div>
        <div class="info">
          <a href="#" class="d-block">Hienltt</a>
        </div>
      </div>

      <!-- Sidebar Menu -->
      <nav class="mt-2">
        <ul class="nav nav-pills nav-sidebar flex-column" data-widget="treeview" role="menu" data-accordion="false">
          <!-- Add icons to the links using the .nav-icon class
               with font-awesome or any other icon font library -->
          <li class="nav-item menu-open">
            <a href="#" class="nav-link active">
              <i class="nav-icon fas fa-table"></i>
              <p>
                Quản trị
                <i class="fas fa-angle-left right"></i>
              </p>
            </a>
            <ul class="nav nav-treeview">
              <li class="nav-item">
                <a href="index.voucher.html" class="nav-link ">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Vouchers</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="index.menu.html" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Menus</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="index.drink.html" class="nav-link active">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Drinks</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="index.countryregion.html" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Country/Region</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="index.userorder.html" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>User/Order</p>
                </a>
              </li>
            </ul>
          </li>
        </ul>
      </nav>
      <!-- /.sidebar-menu -->
    </div>
    <!-- /.sidebar -->
  </aside>

  <!-- Content Wrapper. Contains page content -->
  <div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <section class="content-header">
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-12 text-center">
            <h1>Quản trị Drinks</h1>
          </div>
        </div>
      </div><!-- /.container-fluid -->
    </section>
    <!-- Main content -->
    <section class="content">
      <div class="container-fluid">
        <div class="row">
          <div class="col-12">
            <div class="card">
              <div class="card-body">
                <div class="container">
                  <div class="jumbotron container">
                    <div class="row form-group">
                    <div class="col-sm-3">
                      <label for="drink-code">Mã Nước uống</label>
                    </div>
                    <div class="col-sm-9">
                      <input type="text" id="input-drink-code" name="drink-code" placeholder="Drink code" class="form-control">
                    </div>
                    </div>
                    <div class="row form-group">
                    <div class="col-sm-3">
                      <label for="drink-name">Tên Nước uống</label>
                    </div>
                    <div class="col-sm-9">
                      <input type="text" id="input-drink-name" name="drink-name" placeholder="Drink name" class="form-control">
                    </div>
                    </div>
                    <div class="row form-group">
                    <div class="col-sm-3">
                      <label for="price">Đơn giá</label>
                    </div>
                    <div class="col-sm-9">
                      <input type="number" id="input-price" name="price" placeholder="Đơn giá" class="form-control">
                    </div>
                    </div>
                    <div class="row form-group">
                    <div class="col-sm-3">
                      <label for="createDate">Ngày Tạo</label>
                    </div>
                    <div class="col-sm-9">
                      <input type="text" id="input-createDate" name="createDate" placeholder="Create Date" class="form-control" disabled>
                    </div>
                    </div>
                    <div class="row form-group">
                    <div class="col-sm-3">
                      <label for="updateDate">Ngày sửa</label>
                    </div>
                    <div class="col-sm-9">
                      <input type="text" id="input-updateDate" name="updateDate" placeholder="Update Date" class="form-control" disabled>
                    </div>
                    </div>
                    <div class="row pull-right">
                    <div class="col-sm-12 text-right">
                      <button id="add_data" class="btn btn-success mr-3">Add Drink</button>
                      <button id="save_data" class="btn btn-info mr-3">Save Drink</button>
                      <button id="delete_data" class="btn btn-danger mr-3">Delete Drink</button>
                    </div>
                    </div>
                  </div>
                </div>
                <table class="table table-bordered table-striped table-hover" id="drink-table">
                  <thead>
                    <tr>
                      <th>STT</th>
                      <th>Mã Nước uống</th>
                      <th>Tên Nước uống</th>
                      <th>Đơn giá</th>
                      <th>Ngày tạo</th>
                      <th>Ngày cập nhật</th>
                    </tr>
                </table>
              </div>
            </div>
            <!-- /.card -->
          </div>
          <!-- /.col -->
        </div>
        <!-- /.row -->
      </div>
      <!-- /.container-fluid -->
    </section>
    <!-- /.content -->
  </div>
</div>
<!-- ./wrapper -->

<!-- jQuery -->
<script src="plugins/jquery/jquery.min.js"></script>
<!-- Bootstrap 4 -->
<script src="plugins/bootstrap/js/bootstrap.bundle.min.js"></script>
<!-- DataTables  & Plugins -->
<script src="plugins/datatables/jquery.dataTables.min.js"></script>
<script src="plugins/datatables-bs4/js/dataTables.bootstrap4.min.js"></script>
<script src="plugins/datatables-responsive/js/dataTables.responsive.min.js"></script>
<script src="plugins/datatables-responsive/js/responsive.bootstrap4.min.js"></script>
<script src="plugins/datatables-buttons/js/dataTables.buttons.min.js"></script>
<script src="plugins/datatables-buttons/js/buttons.bootstrap4.min.js"></script>
<script src="plugins/jszip/jszip.min.js"></script>
<script src="plugins/pdfmake/pdfmake.min.js"></script>
<script src="plugins/pdfmake/vfs_fonts.js"></script>
<script src="plugins/datatables-buttons/js/buttons.html5.min.js"></script>
<script src="plugins/datatables-buttons/js/buttons.print.min.js"></script>
<script src="plugins/datatables-buttons/js/buttons.colVis.min.js"></script>
<!-- AdminLTE App -->
<script src="dist/js/adminlte.min.js"></script>
</body>
<script>
  $(document).ready(function(){
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    var gDrinkId = 0;
    var STT = 1;
    // định nghĩa table drink
    var table = $("#drink-table").DataTable({
        "columns": [
            {"data":"stt"},
            {"data":"maNuocUong"},
            {"data":"tenNuocUong"},
            {"data":"donGia"},
            {"data":"ngayTao"},
            {"data":"ngayCapNhat"},
        ],
        columnDefs: [
            {
              targets: 0,
              render: function (){
                return STT++;
              }
            }
        ],
        searching: false,
    })
    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    onPageLoading();
    //Gán event handler khi click vào hàng bất kỳ
    $("#drink-table").on("click", "td", function() {
			onTableRowClick(this);
		});
    // gán sự kiện cho nút add drink
    $("#add_data").on("click", function() {
        onBtnCreateDrinkClick();
    });
    // gán sự kiện cho nút update voucher
      $("#save_data").on("click", function() {
      onBtnUpdateDrinkClick();
    });
    // gán sự kiện cho nút delete drink
      $("#delete_data").on("click", function() {
      onBtnDeleteDrinkClick();
    });
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    //hàm load trang
    function onPageLoading() {
        callAjaxApiGetAllDrinks();
    }
    //Hàm gọi API để lấy ra toàn bộ drink
    function callAjaxApiGetAllDrinks() {
        $.ajax({
            url: "http://localhost:8080/drinks/all",
            type: "GET",
            dataType: "json",
            success: function(res) {
                console.log(res);
                table.clear();
                table.rows.add(res);
                table.draw();
            },
            error: function(err) {
                console.log(err.response);
            }
        })
    }
    //Hàm thực thi khi click vào hàng bất kỳ
    function onTableRowClick(paramTableCell) {
			var vClickedRow = $(paramTableCell).parents("tr");
			var vRowData = table.row(vClickedRow).data();
			gDrinkId = vRowData.stt;			
			console.log("Đã click vào row có id là: " + gDrinkId);
			callAjaxApiGetDrinkById(gDrinkId);
		}
    //Hàm thực thi khi nhấn nút add drink
    function onBtnCreateDrinkClick(){
      var vDrinkData = {
				maNuocUong: "",
				tenNuocUong: "",
				donGia: "",
			};
      readDrinkDataFromWeb(vDrinkData);
      var vCheck = validateData(vDrinkData);
      if(vCheck){
        $.ajax({
				url: "http://localhost:8080/drinks/create",
				type: "POST",
				contentType: "application/json; charset=UTF-8",
				data: JSON.stringify(vDrinkData),
				success: function(res) {
					console.log(res);
					window.location.reload();
				},
				error: function(err){
					console.log(err.response);
				}
			})
      }
    }
    //Hàm thực thi khi nhấn nút Save drink
    function onBtnUpdateDrinkClick(){
      "use strict";
      if(gDrinkId == 0) {
				alert("Hãy click chọn hàng cần update");
			}
			else {
				var vDrinkData = {
				maNuocUong: "",
				tenNuocUong: "",
				donGia: "",
        };
        readDrinkDataFromWeb(vDrinkData);
        var vCheck = validateData(vDrinkData);
        if(vCheck){
          $.ajax({
            url: "http://localhost:8080/drinks/update/" + gDrinkId,
            type: "PUT",
            contentType: "application/json; charset=UTF-8",
            data: JSON.stringify(vDrinkData),
            success: function(res) {
              console.log(res);
              window.location.reload();
            },
            error: function(err){
              console.log(err.response);
				    }
			    });
        };
			}
    }
    //Hàm thực thi khi nhấn nút Delete
    function onBtnDeleteDrinkClick(){
      "use strict";
      if(gDrinkId == 0) {
				alert("Hãy click chọn hàng cần delete");
			}
			else if(confirm( "Ban có muõn xóa?") == true){
        $.ajax({
          url: "http://localhost:8080/drinks/delete/" + gDrinkId,
          type: "DELETE",
          dataType: "json",
          success: function(res) {
            console.log(res);
            window.location.reload();
          },
          error: function(err){
            console.log(err.response);
          }
        });
      }
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    //Hàm gọi API để lấy dữ liệu drink theo id
    function callAjaxApiGetDrinkById(paramId) {
			$.ajax({
				url: "http://localhost:8080/drinks/details/" + paramId,
				type: "GET",
				dataType: "json",
				success: function(res) {
					console.log(res);
					loadDrinkDataToForm(res);
				},
				error: function(err){
					console.log(err.response);
				}
			})
		}
    //Hàm load dữ liệu drink lên form
    function loadDrinkDataToForm(paramDrink) {
			$("#input-drink-code").val(paramDrink.maNuocUong);
			$("#input-drink-name").val(paramDrink.tenNuocUong);
			$("#input-price").val(paramDrink.donGia);
			let vCreateDate = paramDrink.ngayTao.slice(5, 7) + "-" + paramDrink.ngayTao.slice(8,10) + "-" + paramDrink.ngayTao.slice(0, 4);
      $("#input-createDate").val(vCreateDate);
      if(paramDrink.ngayCapNhat !== null){
        let vUpdateDate = paramDrink.ngayCapNhat.slice(5,7) + "-" + paramDrink.ngayCapNhat.slice(8,10) + "-" + paramDrink.ngayCapNhat.slice(0,4);
        $("#input-updateDate").val(vUpdateDate);
      }
      else {
        $("#input-updateDate").val(null);
      }
		}
    //Hàm thu thập dữ liệu để add
    function readDrinkDataFromWeb(paramDrink) {
			paramDrink.maNuocUong = $("#input-drink-code").val().trim();
			paramDrink.tenNuocUong = $("#input-drink-name").val().trim();
			paramDrink.donGia = $("#input-price").val().trim();	
		}
    //Hàm validate
    function validateData(paramDrink){
      "use strict"
      if(paramDrink.maNuocUong === "") {
      alert("Hãy nhập mã nước uống");
      return false;
    } else if(paramDrink.tenNuocUong === "") {
      alert("Hãy nhập tên nước uống");
      return false;
    } else if(paramDrink.donGia === "") {
      alert("Hãy nhập đơn giá");
      return false;
    } else if(isNaN(paramDrink.donGia)) {
      alert("Đơn giá cần nhập vào phải là số");
      return false;
    }
    return true;
    }

  });
</script>
</html>
